#define GCONF_ENABLE_INTERNALS
#include <gtk/gtk.h>
#include <glade/glade.h>
#include <gconf/gconf-client.h>
#include <gdk/gdkx.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>

#include "gset.h"

#define GCONF_LOCAL_SOURCE "xml::/etc/gconf/gconf.xml.defaults"
#define COMPIZ_SCHEMA "/etc/gconf/schemas/compiz.schemas"


items general[] = {	
	
{"lighting", 		GEN_KEYS, 	"lighting", 			3},
{"fullscreen", 		GEN_KEYS, 	"unredirect_fullscreen_windows",3},
{"opacity", 		GEN_KEYS, 	"opacity_step", 		4},
{"refresh", 		GEN_KEYS, 	"refresh_rate", 		0},
{"refresh_auto", 	GEN_KEYS, 	"detect_refresh_rate", 		3},
{"desktops", 		GEN_KEYS, 	"size", 			0},
{"def_icon", 		GEN_KEYS, 	"default_icon", 		6},
{"Best", 		GEN_ALL_KEYS, 	"texture_filter", 		7},
{"Good", 		GEN_ALL_KEYS, 	"texture_filter", 		7},
{"Fast", 		GEN_ALL_KEYS, 	"texture_filter", 		7},
{"raise", 		GEN_ALL_KEYS, 	"raise_on_click", 		3},
{"autoraise", 		GEN_ALL_KEYS, 	"autoraise", 			3},
{"bell", 		GEN_ALL_KEYS, 	"audible_bell", 		3},
{"raise_delay", 	GEN_ALL_KEYS, 	"autoraise_delay", 		4},
{"focus", 		GEN_ALL_KEYS, 	"click_to_focus", 		3},
{"END","","",0}
};

items plugs[] = {

{"Cube_in", 		CUBE_KEYS, 	"in", 				3},
{"Cube_scale_top",	CUBE_KEYS, 	"scale_image_top", 		3},
{"Cube_scale_bottom", 	CUBE_KEYS, 	"scale_image_bottom", 		3},
{"Cube_rotate", 	CUBE_KEYS, 	"rotate_images", 		3},
{"Cube_skydome", 	CUBE_KEYS, 	"skydome", 			3},
{"Cube_sky_ani", 	CUBE_KEYS, 	"skydome_animated", 		3},
{"Cube_sky_image", 	CUBE_KEYS, 	"skydome_image", 		6},
{"Cube_color_button", 	CUBE_KEYS, 	"color", 			8},
{"Cube_mipmap", 	CUBE_KEYS, 	"mipmap", 			3},
{"Cube_speed", 		CUBE_KEYS, 	"speed", 			2},
{"Cube_timestep", 	CUBE_KEYS, 	"timestep", 			2},
{"Cube_accel", 		CUBE_KEYS, 	"acceleration", 		2},

{"Fade_speed", 		FADE_KEYS, 	"fade_speed", 			2},
{"Fade_bell", 		FADE_KEYS, 	"visual_bell", 			3},
{"Fade_bell_full",	FADE_KEYS, 	"fullscreen_visual_bell", 	3},
{"Fade_urgent",		FADE_KEYS, 	"urgent", 			3},
{"Fade_ur_speed",	FADE_KEYS, 	"urgent_speed", 		4},
{"Fade_ur_swing",	FADE_KEYS, 	"urgent_swing", 		4},
{"Fade_ur_count",	FADE_KEYS, 	"urgent_count",			0},
{"Fade_ur_bright",	FADE_KEYS, 	"urgent_center", 		4},

{"Deco_opacity", 	DECO_KEYS, 	"shadow_opacity",		2},
{"Deco_radius", 		DECO_KEYS, 	"shadow_radius",		2},
{"Deco_x", 		DECO_KEYS, 	"shadow_offset_x",		4},
{"Deco_y", 		DECO_KEYS, 	"shadow_offset_y",		4},
{"Deco_color", 		DECO_KEYS, 	"shadow_color",			9},

// Trevio (3v1n0): New Decoration Options - START
{"Deco_use_new", 			DECO_KEYS, 	"use_new_decor", 		3},
{"Deco_win_frame_halo", 		DECO_KEYS, 	"window_frame_halo", 	9},
{"Deco_inactive_inner_alpha", 	DECO_KEYS,	"inactive_inner_alpha", 	2},
{"Deco_use_active_colors", 	DECO_KEYS,	"use_active_colors",	 	3},
{"Deco_inactive_text_halo", 		DECO_KEYS,	"inactive_text_halo", 		9},
{"Deco_inactive_text", 		DECO_KEYS, 	"inactive_text", 			9},
{"Deco_inactive_outer_alpha", 	DECO_KEYS,	"inactive_outer_alpha", 	2},
{"Deco_inactive_outer", 		DECO_KEYS,	"inactive_outer",			9},
{"Deco_inactive_inner", 		DECO_KEYS,	"inactive_inner", 		9},
{"Deco_inactive_button_halo", 	DECO_KEYS,	"inactive_button_halo", 	9},
{"Deco_inactive_button_alpha", 	DECO_KEYS,	"inactive_button_alpha", 	2},
{"Deco_inactive_button", 		DECO_KEYS,	"inactive_button", 		9},
{"Deco_draw_separator_line", 	DECO_KEYS,	"draw_separator_line", 	3},
{"Deco_active_text_halo", 		DECO_KEYS,	"active_text_halo", 		9},
{"Deco_active_text", 			DECO_KEYS,	"active_text", 			9},
{"Deco_active_outer_alpha", 	DECO_KEYS,	"active_outer_alpha", 		2},
{"Deco_active_outer", 		DECO_KEYS, 	"active_outer", 			9},
{"Deco_active_inner_alpha", 	DECO_KEYS,	"active_inner_alpha", 		2},
{"Deco_active_inner", 			DECO_KEYS, 	"active_inner", 			9},
{"Deco_active_button_halo", 	DECO_KEYS,	"active_button_halo", 		9},
{"Deco_active_button_alpha", 	DECO_KEYS,	"active_button_alpha", 	2},
{"Deco_active_button", 		DECO_KEYS, 	"active_button", 			9},
// Trevio (3v1n0): New Decoration Options - END

{"Mini_speed", 		MINI_KEYS, 	"speed", 			2},
{"Mini_timestep", 	MINI_KEYS, 	"timestep", 			2},
{"Mini_zoom", 		MINI_KEYS, 	"zoom_created_windows", 	3},
{"Mini_center", 	MINI_KEYS, 	"zoom_created_windows_from_center",3},

{"Move_opacity", 	MOVE_ALL_KEYS, 	"opacity", 			4}, 
{"Move_con_y", 		MOVE_ALL_KEYS, 	"constrain_y", 			3},	
{"Move_snapoff", 	MOVE_ALL_KEYS, 	"snapoff_maximized",		3},
{"Move_min_opacity", 	MOVE_ALL_KEYS, 	"opacify_min_opacity",		4},

{"Place_work", 		PLACE_KEYS, 	"workarounds", 			3},

{"Resize_min_opacity",	RESIZE_ALL_KEYS, 	"opacify_min_opacity",		4},
{"Resize_opacity", 	RESIZE_ALL_KEYS, 	"opacity", 			4},

{"Scale_darken", 	SCALE_KEYS, 	"darken_back", 			3},
{"Scale_sloppy", 	SCALE_KEYS, 	"sloppy_focus", 		3},
{"Scale_class", 	SCALE_KEYS, 	"use_class", 			3},
{"Scale_speed", 	SCALE_KEYS, 	"speed", 			2},
{"Scale_timestep", 	SCALE_KEYS, 	"timestep", 			2},
{"Scale_space", 	SCALE_KEYS, 	"spacing", 			4},
{"Scale_opacity", 	SCALE_KEYS, 	"opacity", 			4},
{"Scale_desktop", 	SCALE_KEYS, 	"show_desktop", 		3},
{"Scale_darken_factor",	SCALE_KEYS, 	"darken_back_factor", 		2},

{"Rot_accel", 		ROTATE_KEYS, 	"acceleration", 		2},
{"Rot_speed", 		ROTATE_KEYS, 	"speed", 			2},
{"Rot_sens", 		ROTATE_KEYS, 	"sensitivity", 			2},
{"Rot_timestep", 	ROTATE_KEYS, 	"timestep", 			2},
{"Rot_invertx", 	ROTATE_KEYS, 	"invert_x", 			3},
{"Rot_inverty", 	ROTATE_KEYS, 	"invert_y", 			3},
{"Rot_snap", 		ROTATE_KEYS, 	"snap_top", 			3},
{"Rot_snap_bottom", 	ROTATE_KEYS, 	"snap_bottom", 		3},
{"Rot_flip_dnd", 	ROTATE_KEYS, 	"edge_flip_dnd", 		3},
{"Rot_flip_point", 	ROTATE_KEYS, 	"edge_flip_pointer", 		3},
{"Rot_flip_move", 	ROTATE_KEYS, 	"edge_flip_move", 		3},
{"Rot_flip_time", 	ROTATE_KEYS, 	"flip_time", 			4},

{"Swi_opacity", 	SWITCH_KEYS, 	"opacity", 			4},
{"Swi_brightness", 	SWITCH_KEYS, 	"brightness", 			4},
{"Swi_saturation", 	SWITCH_KEYS, 	"saturation", 			4},
{"Swi_speed", 		SWITCH_KEYS, 	"speed", 			2},
{"Swi_timestep", 	SWITCH_KEYS, 	"timestep", 			2},
{"Swi_mipmap", 	SWITCH_KEYS, 	"mipmap", 			3},
{"Swi_minimized", 	SWITCH_KEYS, 	"minimized", 			3},
{"Swi_front", 		SWITCH_KEYS, 	"bring_to_front", 		3},
{"Swi_desktops", 	SWITCH_KEYS, 	"all_desktops", 		3},
{"Swi_icon", 		SWITCH_KEYS, 	"icon", 			3},
{"Swi_zoom", 		SWITCH_KEYS, 	"zoom", 			2},
{"Swi_icon_pos", 	SWITCH_KEYS, 	"icon_corner", 			10},
{"Swi_icon_size", 	SWITCH_KEYS, 	"max_icon_size", 		0},


{"Wobbly_resolution", 	WOBBLY_KEYS, 	"grid_resolution", 		0},
{"Wobbly_gridsize",	WOBBLY_KEYS, 	"min_grid_size", 		0},
{"Wobbly_grab_fri", 	WOBBLY_KEYS, 	"grab_friction",		2},
{"Wobbly_grab_spr",	WOBBLY_KEYS, 	"grab_spring_k", 		2},
{"Wobbly_map_fri", 	WOBBLY_KEYS, 	"map_friction",		2},
{"Wobbly_map_spr",	WOBBLY_KEYS, 	"map_spring_k", 		2},
{"Wobbly_move_fri", 	WOBBLY_KEYS, 	"move_friction", 		2},
{"Wobbly_move_spr",	WOBBLY_KEYS, 	"move_spring_k", 		2},
{"Wobbly_focus_fri", 	WOBBLY_KEYS, 	"focus_frictrun_ion",	 	2},
{"Wobbly_focus_spr",	WOBBLY_KEYS, 	"focus_spring_k", 		2},
{"Wobbly_max_fx",	WOBBLY_KEYS, 	"maximize_effect", 		3},
{"Wobbly_max_fri", 	WOBBLY_KEYS, 	"maximize_friction",	 	2},
{"Wobbly_max_spr",	WOBBLY_KEYS, 	"maximize_spring_k", 		2},
{"Wobbly_focus_fx", 	WOBBLY_KEYS, 	"focus_effect", 		5},
{"Wobbly_map_fx", 	WOBBLY_KEYS, 	"map_effect", 			5},
{"Wobbly_bell", 	WOBBLY_KEYS, 	"visual_bell", 			3},
{"Wobbly_bell_fri", 	WOBBLY_KEYS, 	"visual_bell_friction",		2},
{"Wobbly_bell_spr",	WOBBLY_KEYS, 	"visual_bell_spring_k", 	2},
{"Wobbly_rel_fx", 	WOBBLY_KEYS, 	"release_effect", 		3},
{"Wobbly_rel_fri", 	WOBBLY_KEYS, 	"release_friction",		2},
{"Wobbly_rel_spr",	WOBBLY_KEYS, 	"release_spring_k", 		2},
{"Wobbly_reverse", 	WOBBLY_KEYS, 	"default_snap", 		3},

{"Zoom_speed", 	ZOOM_KEYS, 	"speed", 			2},
{"Zoom_sens", 		ZOOM_KEYS, 	"sensitivity", 			2},
{"Zoom_timestep", 	ZOOM_KEYS, 	"timestep", 			2},
{"Zoom_filter", 	ZOOM_KEYS, 	"filter_linear", 		3},
{"Zoom_inverty", 	ZOOM_KEYS, 	"invert_y", 			3},
{"Zoom_min", 		ZOOM_KEYS, 	"min", 			2},
{"Zoom_max", 		ZOOM_KEYS, 	"max", 			2},
{"Zoom_multi", 	ZOOM_KEYS, 	"step", 			2},

{"Bs_bright", 		BS_KEYS, 	"brightness_step", 		0},
{"Bs_sat", 		BS_KEYS, 	"saturation_step", 		0},

{"Water_offset", 	WATER_ALL_KEYS, 	"offset_scale", 		2},
{"Water_delay", 	WATER_ALL_KEYS, 	"rain_delay", 			0},
{"Water_bell", 		WATER_ALL_KEYS, 	"visual_bell", 			3},

{"Miniwin_ontop", 	MINIWIN_KEYS, 	"always_on_top", 		3},
{"Miniwin_hide_dock", 	MINIWIN_KEYS, 	"hide_dock_on_click", 		3},
{"Miniwin_move_up", 	MINIWIN_KEYS, 	"only_move_up", 		3},
{"Miniwin_onall", 	MINIWIN_KEYS, 	"on_all_workspaces", 		3},
{"Miniwin_aiglx", 	MINIWIN_KEYS, 	"runs_on_aiglx", 		3},
{"Miniwin_show_dock", 	MINIWIN_KEYS, 	"show_dock", 			3},
{"Miniwin_taskbar", 	MINIWIN_KEYS, 	"use_as_taskbar", 		3},
{"Miniwin_t_opacity", 	MINIWIN_KEYS,	"dock_opacity", 		4},
{"Miniwin_t_spacing", 	MINIWIN_KEYS, 	"taskbar_spacing", 		4},
{"Miniwin_w_opacity", 	MINIWIN_KEYS, 	"mindow_opacity", 		4},
{"Miniwin_w_width", 	MINIWIN_KEYS, 	"mindow_width", 		4},
{"Miniwin_h_opacity", 	MINIWIN_KEYS, 	"opacity_on_hover", 		4},
{"Miniwin_h_scale", 	MINIWIN_KEYS, 	"scale_on_hover_factor", 	2},

{"Dock_from_ws", 	DOCK_KEYS, 	"from_all_workspaces", 	3},
{"Dock_maximized", 	DOCK_KEYS, 	"show_maximized_windows", 	3},
{"Dock_aiglx", 		DOCK_KEYS, 	"runs_on_aiglx", 		3},
{"Dock_hide", 		DOCK_KEYS, 	"hide_dock_on_click", 		3},
{"Dock_d_op", 		DOCK_KEYS,	"dock_opacity", 		4},
{"Dock_d_space", 	DOCK_KEYS, 	"taskbar_spacing", 		4},
{"Dock_i_op", 		DOCK_KEYS, 	"icon_opacity", 		4},
{"Dock_i_width", 	DOCK_KEYS, 	"icon_width", 			4},
{"Dock_h_op", 		DOCK_KEYS, 	"opacity_on_hover", 		4},
{"Dock_h_scale", 	DOCK_KEYS, 	"scale_on_hover_factor", 	2},
{"Dock_position", 	DOCK_KEYS, 	"dock_position", 		10},
{"Dock_ani", 		DOCK_KEYS, 	"animation_time",		0},

{"Trail_count", 	TRAIL_KEYS, 	"maximum_trail_count", 	  0},
{"Trail_op_max", 	TRAIL_KEYS, 	"maximum_window_opacity_level",   4},
{"Trail_op_min", 	TRAIL_KEYS, 	"minimum_window_opacity_level",   4},
{"Trail_br_max", 	TRAIL_KEYS, 	"maximum_window_brightness_level",4},
{"Trail_br_min", 	TRAIL_KEYS, 	"minimum_window_brightness_level",4},
{"Trail_sat_max",	TRAIL_KEYS, 	"maximum_window_saturation_level",4},
{"Trail_sat_min", 	TRAIL_KEYS, 	"minimum_window_saturation_level",4},	

/* 		vanilla keys		*/

{"Cube_scale", 		CUBE_KEYS, 	"scale_image", 	3},
{"Wobbly_friction", 	WOBBLY_KEYS, 	"friction", 		2},
{"Wobbly_spring", 	WOBBLY_KEYS, 	"spring_k", 		2},
{"END","","",0}
};

items shorts[] = {

{"Gen_menu", 		GEN_ALL_KEYS, 	"main_menu_key", 		1},
{"Gen_run", 		GEN_ALL_KEYS, 	"run_key", 			1},
{"Gen_window_menu", 	GEN_ALL_KEYS, 	"window_menu_key", 		1},
{"Gen_wMin", 		GEN_ALL_KEYS, 	"minimize_window_key", 		1},
{"Gen_wMax", 		GEN_ALL_KEYS, 	"maximize_window_key", 		1},
{"Gen_wUnmax", 	GEN_ALL_KEYS, 	"unmaximize_window_key", 		1},
{"Gen_wLower", 		GEN_ALL_KEYS, 	"lower_window_key", 		1},
{"Gen_wClose", 		GEN_ALL_KEYS, 	"close_window_key", 		1},
{"Gen_incOpacity", 	GEN_ALL_KEYS, 	"opacity_increase_key",		1},
{"Gen_decOpacity", 	GEN_ALL_KEYS, 	"opacity_decrease_key",		1},
{"Gen_slowAni", 	GEN_ALL_KEYS, 	"slow_animations_key", 		1},
{"Gen_screen", 		GEN_ALL_KEYS, 	"run_command_screenshot_key", 	1},
{"Gen_window", 		GEN_ALL_KEYS, 	"run_command_window_screenshot_key",1},
{"Gen_screen_com", 	GEN_ALL_KEYS, 	"command_screenshot", 		1},
{"Gen_window_com", 	GEN_ALL_KEYS, 	"command_window_screenshot", 	1},
{"Gen_desktop", 	GEN_ALL_KEYS, 	"show_desktop_key", 		1},
	
{"Gen_key1", 		GEN_ALL_KEYS, 	"run_command0_key", 		1},
{"Gen_com1", 		GEN_ALL_KEYS, 	"command0", 			1},
{"Gen_key2", 		GEN_ALL_KEYS, 	"run_command1_key", 		1},
{"Gen_com2", 		GEN_ALL_KEYS, 	"command1", 			1},
{"Gen_key3", 		GEN_ALL_KEYS, 	"run_command2_key", 		1},
{"Gen_com3", 		GEN_ALL_KEYS, 	"command2", 			1},
{"Gen_key4", 		GEN_ALL_KEYS, 	"run_command3_key", 		1},
{"Gen_com4", 		GEN_ALL_KEYS, 	"command3", 			1},
{"Gen_key5", 		GEN_ALL_KEYS, 	"run_command4_key", 		1},
{"Gen_com5", 		GEN_ALL_KEYS, 	"command4", 			1},
{"Gen_key6", 		GEN_ALL_KEYS, 	"run_command5_key", 		1},
{"Gen_com6", 		GEN_ALL_KEYS, 	"command5", 			1},
{"Gen_key7", 		GEN_ALL_KEYS, 	"run_command6_key", 		1},
{"Gen_com7", 		GEN_ALL_KEYS, 	"command6", 			1},
{"Gen_key8", 		GEN_ALL_KEYS, 	"run_command7_key", 		1},
{"Gen_com8", 		GEN_ALL_KEYS, 	"command7", 			1},
{"Gen_key9", 		GEN_ALL_KEYS, 	"run_command8_key", 		1},
{"Gen_com9", 		GEN_ALL_KEYS, 	"command8", 			1},
{"Gen_key10", 		GEN_ALL_KEYS, 	"run_command9_key", 		1},
{"Gen_com10", 		GEN_ALL_KEYS, 	"command9", 			1},
{"Gen_key11", 		GEN_ALL_KEYS, 	"run_command10_key", 		1},
{"Gen_com11", 		GEN_ALL_KEYS, 	"command10", 			1},
{"Gen_key12", 		GEN_ALL_KEYS, 	"run_command11_key", 		1},
{"Gen_com12", 		GEN_ALL_KEYS, 	"command11", 			1},

{"Cube_next_slide", 	CUBE_ALL_KEYS, 	"next_slide_key", 		1},
{"Cube_prev_slide", 	CUBE_ALL_KEYS, 	"prev_slide_key", 		1},
{"Cube_unfold", 	CUBE_ALL_KEYS, 	"unfold_key", 		1},

{"Move_initiate", 	MOVE_ALL_KEYS, 	"initiate_key", 		1},
	
{"Resize_initiate", 	RESIZE_ALL_KEYS, 	"initiate_key", 		1},

{"Place_center", 	PLACE_KEYS, 	"center_initiate_key",	1},

{"Rotate_initiate", 	ROTATE_ALL_KEYS, 	"initiate_key", 		1},
{"Rotate_left", 	ROTATE_ALL_KEYS, 	"rotate_left_key", 		1},
{"Rotate_right", 	ROTATE_ALL_KEYS, 	"rotate_right_key", 	1},
{"Rotate_left_window", 	ROTATE_ALL_KEYS, 	"rotate_left_window_key", 	1},
{"Rotate_right_window", ROTATE_ALL_KEYS, 	"rotate_right_window_key", 	1},	
{"Rotate_vp1", 		ROTATE_ALL_KEYS, 	"rotate_to_1_key", 		1},	
{"Rotate_vp1_w", 	ROTATE_ALL_KEYS, 	"rotate_to_1_window_key", 	1},
{"Rotate_vp2", 		ROTATE_ALL_KEYS, 	"rotate_to_2_key", 		1},	
{"Rotate_vp2_w", 	ROTATE_ALL_KEYS, 	"rotate_to_2_window_key", 	1},
{"Rotate_vp3", 		ROTATE_ALL_KEYS, 	"rotate_to_3_key", 		1},	
{"Rotate_vp3_w", 	ROTATE_ALL_KEYS, 	"rotate_to_3_window_key", 	1},
{"Rotate_vp4", 		ROTATE_ALL_KEYS, 	"rotate_to_4_key", 		1},	
{"Rotate_vp4_w", 	ROTATE_ALL_KEYS, 	"rotate_to_4_window_key", 	1},
{"Rotate_vp5", 		ROTATE_ALL_KEYS, 	"rotate_to_5_key", 		1},	
{"Rotate_vp5_w", 	ROTATE_ALL_KEYS, 	"rotate_to_5_window_key", 	1},
{"Rotate_vp6", 		ROTATE_ALL_KEYS, 	"rotate_to_6_key", 		1},	
{"Rotate_vp6_w", 	ROTATE_ALL_KEYS, 	"rotate_to_6_window_key", 	1},
{"Rotate_vp7", 		ROTATE_ALL_KEYS, 	"rotate_to_7_key", 		1},	
{"Rotate_vp7_w", 	ROTATE_ALL_KEYS, 	"rotate_to_7_window_key", 	1},
{"Rotate_vp8", 		ROTATE_ALL_KEYS, 	"rotate_to_8_key", 		1},	
{"Rotate_vp8_w", 	ROTATE_ALL_KEYS, 	"rotate_to_8_window_key", 	1},
{"Rotate_vp9", 		ROTATE_ALL_KEYS, 	"rotate_to_9_key", 		1},	
{"Rotate_vp9_w", 	ROTATE_ALL_KEYS, 	"rotate_to_9_window_key", 	1},
{"Rotate_vp10", 	ROTATE_ALL_KEYS, 	"rotate_to_10_key", 	1},	
{"Rotate_vp10_w", 	ROTATE_ALL_KEYS, 	"rotate_to_10_window_key", 	1},
{"Rotate_vp11", 	ROTATE_ALL_KEYS, 	"rotate_to_11_key", 	1},	
{"Rotate_vp11_w", 	ROTATE_ALL_KEYS, 	"rotate_to_11_window_key", 	1},
{"Rotate_vp12", 	ROTATE_ALL_KEYS, 	"rotate_to_12_key", 	1},	
{"Rotate_vp12_w", 	ROTATE_ALL_KEYS, 	"rotate_to_12_window_key", 	1},

{"Scale_init", 		SCALE_ALL_KEYS,	"initiate_key", 		1},	
{"Scale_term", 	SCALE_ALL_KEYS, 	"terminate_key", 		1},
{"Scale_init_curr", 	SCALE_ALL_KEYS, 	"initiate_current_key", 	1},
{"Scale_term_curr", 	SCALE_ALL_KEYS, 	"terminate_current_key", 	1},
{"Scale_init_all", 	SCALE_ALL_KEYS, 	"initiate_all_screens_key", 1},
{"Scale_term_all", 	SCALE_ALL_KEYS, 	"terminate_all_screens_key",1},
{"Scale_next", 		SCALE_ALL_KEYS, 	"next_window_key", 		1},
{"Scale_prev", 		SCALE_ALL_KEYS, 	"prev_window_key", 		1},	

{"Switch_init", 	SWITCH_ALL_KEYS, 	"initiate_key", 		1},
{"Switch_init_all", 	SWITCH_ALL_KEYS, 	"initiate_all_key", 	1},
{"Switch_prev", 	SWITCH_ALL_KEYS, 	"prev_window_key", 		1},
	
{"Wobbly_snap", 	WOBBLY_KEYS, 	"snap_key", 		1},

{"Zoom_init", 		ZOOM_ALL_KEYS, 	"initiate_key", 		1},
{"Zoom_in", 		ZOOM_ALL_KEYS, 	"zoom_in_key", 		1},
{"Zoom_out",		ZOOM_ALL_KEYS, 	"zoom_out_key", 		1},

{"Water_init", 		WATER_ALL_KEYS, 	"initiate_key", 		1},
{"Water_rain", 		WATER_ALL_KEYS, 	"toggle_rain_key", 		1},

{"Dock_unicon", 	DOCK_KEYS, 	"uniconify_key", 	1},
{"Dock_dock", 		DOCK_KEYS, 	"set_dock_background_key",1},	

{"Miniwin_icon", 	MINIWIN_KEYS, 	"mindow_key", 		1},
{"Miniwin_deicon", 	MINIWIN_KEYS, 	"demindow_key", 	1},
{"Miniwin_background", 	MINIWIN_KEYS, 	"set_dock_background_key",1},
	
{"Bs_bri_inc", 		BS_KEYS, 	"brightness_increase_key", 	1},
{"Bs_bri_dec", 		BS_KEYS, 	"brightness_decrease_key", 	1},
{"Bs_sat_inc", 		BS_KEYS, 	"saturation_increase_key", 	1},
{"Bs_sat_dec", 		BS_KEYS, 	"saturation_decrease_key", 	1},
{"END","","",0}
};

items windows[]= {

{"Fade_windows", 	FADE_KEYS, 	"window_types", 	0},
{"Mini_windows", 	MINI_KEYS, 	"window_types", 	0},
{"Scale_windows", 	SCALE_KEYS, 	"window_types", 	0},
{"Swi_windows", 	SWITCH_KEYS, 	"window_types", 	0},
{"Miniwin_windows", 	MINIWIN_KEYS, 	"window_type", 		0},
{"Dock_windows", 	DOCK_KEYS, 	"window_type", 		0},
{"END","","",0}
};

items *ptr;

static GladeXML *xml;
static GConfClient *client;

int main (int argc, char **argv)
{
	gtk_init (&argc, &argv);

	GtkWidget *preview, *widget;
	GtkFileFilter *filter;
	GPtrArray *img_stores;
	GtkTreeModel *model;
	GError *err = NULL;
	GConfEngine *conf;
	
	#ifdef DATADIR
		
		GString *g= g_string_new (DATADIR);	
		g = g_string_append (g, "/gset.glade"); 
		xml = glade_xml_new (g->str, NULL, NULL);		
		g_string_free (g, TRUE);			
	#else
		xml = glade_xml_new ("gset.glade", NULL, NULL);		
	#endif
	
	#ifdef PIXDIR

		GString *i= g_string_new (PIXDIR);
        	i = g_string_append (i, "/gset-compiz.png");	
		gtk_window_set_default_icon_from_file (i->str, NULL);
		
		widget = glade_xml_get_widget (xml, "Main");
		gtk_window_set_icon_from_file (GTK_WINDOW (widget), 
						i->str, NULL);
		g_string_free (i, TRUE);
	#else
		widget = glade_xml_get_widget (xml, "Main");
		gtk_window_set_icon_from_file (GTK_WINDOW (widget), 
					       "gset-compiz.png", NULL);
		gtk_window_set_default_icon_from_file ("gset-compiz.png", NULL);
	#endif
		
	glade_xml_signal_autoconnect(xml);
	
	XErrorHandler handler = XSetErrorHandler (X_error);
	
	if (geteuid() == 0) {
		conf = gconf_engine_get_for_address(GCONF_LOCAL_SOURCE, &err);
		if (conf  == NULL) {
			g_assert(err != NULL);
			fprintf(stderr, "Failed to access configuration source(s): %s\n", err->message);
			g_error_free(err);
			exit(1);
		}
	} else {
		conf = gconf_engine_get_default ();
	}
	client = gconf_client_get_for_engine(conf);

	gconf_client_set_global_default_error_handler 
			((GConfClientErrorHandlerFunc) gconf_error_handling);
	
	widget = glade_xml_get_widget (xml, "About");
	gtk_about_dialog_set_version (GTK_ABOUT_DIALOG (widget), VERSION);
	gtk_about_dialog_set_logo (GTK_ABOUT_DIALOG (widget), NULL);
	
	widget = glade_xml_get_widget (xml, "Slide_file_dialog");	
	filter = gtk_file_filter_new ();	
	gtk_file_filter_add_pattern (filter, "*.svg");
	gtk_file_filter_add_pattern (filter, "*.png");
	gtk_file_chooser_set_filter (GTK_FILE_CHOOSER (widget), filter);
	
	preview = gtk_image_new ();
	gtk_file_chooser_set_preview_widget (GTK_FILE_CHOOSER (widget), 
					     GTK_WIDGET (preview));
  	g_signal_connect (widget, "update-preview", G_CALLBACK (update_preview), 
  						  		     preview);	
	
	widget = glade_xml_get_widget (xml, "State_type");
	gtk_combo_box_set_active (GTK_COMBO_BOX (widget), 0);
	widget = glade_xml_get_widget (xml, "State_attrib");
	gtk_combo_box_set_active (GTK_COMBO_BOX (widget), 0);
	
	for (ptr=&general[0]; ptr->name != "END"; ptr++)
		get_gconf_keys ();
	
	for (ptr=&plugs[0]; ptr->name != "END";ptr++)
		get_gconf_keys ();	
	
	for (ptr=&windows[0]; ptr->name != "END"; ptr++)
		choose_window_types ();	
	
	for (ptr=&shorts[0]; ptr->name != "END"; ptr++) {
		widget = glade_xml_get_widget (xml, ptr->name);
		g_signal_handlers_block_by_func (widget, 
						(GCallback) value_changed, 
						NULL);
		get_gconf_keys ();
		g_signal_handlers_unblock_by_func (widget, 
						  (GCallback) value_changed,
						  NULL);
	}
	
	active_plugins ();
	choose_corner_list ();	
	own_config ();
	images_list ();
	
	img_stores = g_ptr_array_new ();	
	model = create_top_image_store ();	
	g_ptr_array_add (img_stores, model);	
	model = create_bottom_image_store ();
	g_ptr_array_add (img_stores, model);
	
	widget = glade_xml_get_widget (xml, "image_position");	
	g_signal_connect (widget, "changed", G_CALLBACK
					  (image_position_changed), img_stores);
	gtk_combo_box_set_active (GTK_COMBO_BOX (widget), 0);
	
	widget = glade_xml_get_widget (xml, "slide_preview");	
	g_signal_connect (widget, "changed", G_CALLBACK
					  (slide_preview_size), img_stores);
	g_signal_emit_by_name (widget, "changed");	
	
	wobbly_fx_types ();
	trailfocus_list ();
	state_list ();
	
	gtk_main ();

	g_ptr_array_free (img_stores, TRUE);

	gconf_client_suggest_sync(client, &err);
	if (err != NULL) {
		fprintf(stderr, "Error syncing config data: %s", err->message);
		g_error_free(err);
		exit(1);
	}

	if (geteuid() == 0) {
		g_spawn_command_line_sync ("/usr/bin/killall -q -HUP gconfd-2", NULL, NULL, NULL, NULL);
	}

	g_object_unref (client);

    	return 0;
}

/*	main window callbacks	*/

void plugins_toggled (GtkCellRendererToggle *cell, gchar *path_string,
						   gpointer store)
{
	GtkTreeIter iter;
	gboolean state;
	
	gtk_tree_model_get_iter_from_string (store, &iter, path_string);
	state = gtk_cell_renderer_toggle_get_active (cell);
	gtk_list_store_set (store, &iter, 0, !state, -1);	
	
	set_active_plugins ();
	
	g_usleep (300000);		
	active_plugins_store (store);
	set_sensitivity ();
}

void editable_changed_main (GtkEditable *editable, gpointer user_data)
{
	const gchar *name = glade_get_widget_name (GTK_WIDGET (editable));
	
	for (ptr=&general[0]; ptr->name != "END"; ptr++) {
		if (strncmp (ptr->name, name, 32) == 0)
			break;
	}	
	set_gconf_keys ();	
}

void toggle_changed_main (GtkToggleButton *toggle, gpointer user_data)
{
	const gchar *name = glade_get_widget_name (GTK_WIDGET (toggle));
	
	for (ptr=&general[0]; ptr->name != "END"; ptr++) {
		if (strncmp (ptr->name, name, 32) == 0)
			break;
	}		
	set_gconf_keys ();	
}

void range_changed_main (GtkRange *range, gpointer user_data)
{
	const gchar *name = glade_get_widget_name (GTK_WIDGET (range));
	
	for (ptr=&general[0]; ptr->name != "END"; ptr++) {
		if (strncmp (ptr->name, name, 32) == 0)
			break;
	}		
	set_gconf_keys ();	
}

void file_changed_main (GtkFileChooser *chooser, gpointer user_data)
{
	const gchar *name = glade_get_widget_name (GTK_WIDGET (chooser));
	
	for (ptr=&general[0]; ptr->name != "END"; ptr++) {
		if (strncmp (ptr->name, name, 32) == 0)
			break;
	}		
	set_gconf_keys ();	
}

/* 	menu callbacks		*/

void menu_plugins (GtkMenuItem *menuitem, gpointer data)
{
	toolbutton_plug (NULL, NULL);
}

void menu_shortcuts (GtkMenuItem *menuitem, gpointer data)
{
	toolbutton_short (NULL, NULL);
}

void menu_images (GtkMenuItem *menuitem, gpointer data)
{
	select_image_button (NULL, NULL);
}

void menu_about (GtkMenuItem *menuitem, gpointer data)
{
	GtkWidget *widget = glade_xml_get_widget (xml, "About");

	g_signal_connect_swapped(widget, "response",
				 G_CALLBACK(gtk_widget_hide), widget);

	gtk_widget_show (widget);
}

void menu_show_tool (GtkCheckMenuItem *checkmenuitem, gpointer data)
{
	GtkWidget *toolbar = glade_xml_get_widget(xml, "toolbar");
	gboolean show = gtk_check_menu_item_get_active (checkmenuitem);

	gconf_client_set_bool (client, "/apps/gset-compiz/toolbar", show, NULL);
	
	if (show)
		gtk_widget_show (toolbar);
	else
		gtk_widget_hide (toolbar);
}

void menu_version (GtkCheckMenuItem *checkmenuitem, gpointer data)
{
	gboolean show = gtk_check_menu_item_get_active (checkmenuitem);
	gconf_client_set_bool (client, "/apps/gset-compiz/version", show, NULL);
			
	change_version (show);
}

/* 	shortcuts window callbacks	*/

void short_button_close (GtkButton *button, gpointer user_data)
{
	GtkWidget *Shortcuts = glade_xml_get_widget(xml, "Shortcuts");
	gtk_widget_hide (Shortcuts);
}

void short_delete (GtkWidget *widget, GdkEvent *event, gpointer data)
{
	gtk_widget_hide (widget);
}

void value_changed (GtkEditable *editable, gpointer user_data)
{
	const gchar *name = glade_get_widget_name (GTK_WIDGET (editable));
	
	for (ptr=&shorts[0]; ptr->name != "END"; ptr++) {
		if (strncmp (ptr->name, name, 32) == 0)
			break;
	}		
	set_gconf_keys ();
}

gboolean focus_out_short (GtkWidget *widget, GdkEventFocus *event, gpointer data)
{
	const gchar *name = glade_get_widget_name (GTK_WIDGET (widget));
	
	for (ptr=&shorts[0]; ptr->name != "END"; ptr++) {
		if (strncmp (ptr->name, name, 32) == 0)
			break;
	}		
	get_gconf_keys ();

	return FALSE;
}

/* 	plugins window callbacks	*/

void plug_button_close (GtkButton *button, gpointer user_data)
{
	GtkWidget *Plugins = glade_xml_get_widget (xml, "Plugins");
	gtk_widget_hide (Plugins);
}

void plug_delete (GtkWidget *widget, GdkEvent *event, gpointer data)
{
	gtk_widget_hide (widget);
}

void toggle_changed_plug (GtkToggleButton *toggle, gpointer user_data)
{
	const gchar *name = glade_get_widget_name (GTK_WIDGET (toggle));

	for (ptr=&plugs[0]; ptr->name != "END"; ptr++) {
		if (strncmp (ptr->name, name, 32) == 0)
			break;
	}		
	set_gconf_keys ();
}

void combo_changed_plug (GtkComboBox *box, gpointer user_data)
{
	const gchar *name = glade_get_widget_name (GTK_WIDGET (box));

	for (ptr=&plugs[0]; ptr->name != "END"; ptr++) {
		if (strncmp (ptr->name, name, 32) == 0)
			break;
	}		
	set_gconf_keys ();
}

void range_changed_plug (GtkRange *range, gpointer user_data)
{
	const gchar *name = glade_get_widget_name (GTK_WIDGET (range));
	
	for (ptr=&plugs[0]; ptr->name != "END"; ptr++) {
		if (strncmp (ptr->name, name, 32) == 0)
			break;
	}		
	set_gconf_keys ();
}

void editable_changed_plug (GtkEditable *editable, gpointer user_data)
{
	const gchar *name = glade_get_widget_name (GTK_WIDGET (editable));
	
	for (ptr=&plugs[0]; ptr->name != "END"; ptr++) {
		if (strncmp (ptr->name, name, 32) == 0) 
			break;
	}		
	set_gconf_keys ();
}

void file_changed_plug (GtkFileChooser *chooser, gpointer user_data)
{
	const gchar *name = glade_get_widget_name (GTK_WIDGET (chooser));

	for (ptr=&plugs[0]; ptr->name != "END"; ptr++) {
		if (strncmp (ptr->name, name, 32) == 0)
			break;
	}		
	set_gconf_keys ();
}

void color_changed_plug (GtkColorButton *color, gpointer user_data)
{
	const gchar *name = glade_get_widget_name (GTK_WIDGET (color));

	for (ptr=&plugs[0]; ptr->name != "END"; ptr++) {
		if (strncmp (ptr->name, name, 32) == 0)
			break;
	}		
	set_gconf_keys ();
}

/*	about dialog callback	*/

void about_delete (GtkWidget *widget, GdkEvent *event, gpointer data)
{
	gtk_widget_hide (widget);
}

/*	toolbar button callbacks	*/

void toolbutton_plug (GtkButton *button, gpointer user_data)
{
	GtkWidget *plugins = glade_xml_get_widget (xml, "Plugins");
	gtk_widget_show (plugins);
}

void toolbutton_short (GtkButton *button, gpointer user_data)
{	
	GtkWidget *shortcuts = glade_xml_get_widget (xml, "Shortcuts");
	gtk_widget_show (shortcuts);
}

void select_image_button (GtkButton *button, gpointer user_data)
{	
	GtkWidget *widget = glade_xml_get_widget (xml, "Slide");
	gtk_widget_show (widget);
}

void wobbly_toggled (GtkCellRendererToggle *cell, gchar *path_string,
						  gpointer pos)
{
	GtkWidget *list;
	GtkTreeModel *store;
	GtkTreeIter iter;
	gboolean state;
	
	state = gtk_cell_renderer_toggle_get_active (cell);
	list = glade_xml_get_widget (xml, "Wobbly_types");
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (list));
	
	gtk_tree_model_get_iter_from_string (store, &iter, path_string);	
	gtk_list_store_set (GTK_LIST_STORE (store), &iter, pos, !state, -1);	

	set_wobbly_fx ();
}

void window_types_toggled (GtkCellRendererToggle *cell, gchar *path_string,
						        gpointer list)
{
	GtkTreeModel *store;
	GtkTreeIter iter;
	const gchar *name;
	gboolean state;		
	
	state = gtk_cell_renderer_toggle_get_active (cell);
	store = gtk_tree_view_get_model (list);
	
	gtk_tree_model_get_iter_from_string (store, &iter, path_string);	
	gtk_list_store_set (GTK_LIST_STORE (store), &iter, 1, !state, -1);	
		
	name = glade_get_widget_name (GTK_WIDGET (list));	
	for (ptr=&windows[0]; ptr->name != "END"; ptr++) {
		
		if (strncmp (ptr->name, name, 32) == 0) {
			set_window_store ();
			break;
		}
	}			
}

void corner_toggled (GtkCellRendererToggle *cell, gchar *path_string,
						      	gpointer pos)
{
	GtkWidget *list;
	GtkTreeModel *store;
	GtkTreeIter iter;
	gboolean state;		
	
	state = gtk_cell_renderer_toggle_get_active (cell);
	list = glade_xml_get_widget (xml, "Scale_corners");
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (list));
	
	gtk_tree_model_get_iter_from_string (store, &iter, path_string);	
	gtk_list_store_set (GTK_LIST_STORE (store), &iter, pos, !state, -1);	

	set_corner_store ();
}

/* 	callbacks for slide selection window		*/

void slide_add (GtkButton *button, gpointer user_data)
{
	GtkWidget *widget = glade_xml_get_widget(xml, "Slide_file_dialog");
	gtk_file_chooser_unselect_all (GTK_FILE_CHOOSER (widget));
	gtk_widget_show (widget);
}

void slide_remove (GtkButton *button, gpointer user_data)
{
	GtkWidget *widget;
	GtkTreeIter iter;
	gboolean valid;
	
	widget = glade_xml_get_widget (xml, "slide_svgs");
	GtkTreeModel *store = gtk_tree_view_get_model (GTK_TREE_VIEW (widget));
	GtkTreeSelection *selection = gtk_tree_view_get_selection
						     (GTK_TREE_VIEW (widget));
	
	valid = gtk_tree_selection_get_selected (selection, &store, &iter);	
	if (valid) {
		gtk_list_store_remove (GTK_LIST_STORE (store), &iter);
	}
}

void slide_up (GtkButton *button, gpointer user_data)
{
	GtkTreeIter iter, iter_new;
	GtkTreePath *path;
	gboolean valid, valid_new;
	GtkWidget *widget = glade_xml_get_widget (xml, "slide_svgs");
	GtkTreeModel *model = gtk_tree_view_get_model (GTK_TREE_VIEW (widget));
	GtkTreeSelection *selection = gtk_tree_view_get_selection
						     (GTK_TREE_VIEW (widget));	
	
	valid = gtk_tree_selection_get_selected (selection, &model, &iter);
	if (valid) {		
		path = gtk_tree_model_get_path (model, &iter);
		valid_new = gtk_tree_path_prev (path);
		
		if (valid_new) {
			gtk_tree_model_get_iter (model, &iter_new, path);
			gtk_list_store_move_before (GTK_LIST_STORE (model),
							  &iter, &iter_new);
		}
		
		gtk_tree_path_free (path);			
	}
}

void slide_down (GtkButton *button, gpointer user_data)
{
	GtkTreeIter iter, iter_new;
	GtkTreePath *path;
	gboolean valid, valid_iter;
	
	GtkWidget *widget = glade_xml_get_widget (xml, "slide_svgs");
	GtkTreeModel *model = gtk_tree_view_get_model (GTK_TREE_VIEW (widget));
	GtkTreeSelection *selection = gtk_tree_view_get_selection
						     (GTK_TREE_VIEW (widget));	
	valid = gtk_tree_selection_get_selected (selection, &model, &iter);
	
	if (valid) {
		path = gtk_tree_model_get_path (model, &iter);
		gtk_tree_path_next (path);
		valid_iter = gtk_tree_model_get_iter (model, &iter_new, path);
		
		if (valid_iter) {
			gtk_list_store_move_after (GTK_LIST_STORE (model), 
						   &iter, &iter_new);
		}		
		gtk_tree_path_free (path);
	}
}

void slide_clear (GtkButton *button, gpointer user_data)
{
	GtkWidget *widget = glade_xml_get_widget (xml, "slide_svgs");
	GtkTreeModel *model = gtk_tree_view_get_model (GTK_TREE_VIEW (widget));
	gtk_list_store_clear (GTK_LIST_STORE (model));
}

void slide_row_delete (GtkTreeModel *treemodel, GtkTreePath  *arg1,
                                            	gpointer data)
{
	set_image_store (data);
}

void slide_row_reorder (GtkTreeModel *treemodel, GtkTreePath  *arg1,
                                            	 GtkTreeIter  *arg2,
                                            	 gpointer arg3,
                                            	 gpointer data)
{
	set_image_store (data);
}                                           

void slide_preview_size (GtkComboBox *box, GPtrArray *ptr) 
{	
	GError *err = NULL;
	GtkTreeModel *model;
	GtkTreeIter iter;
	GdkPixbuf *pixbuf;
	gchar *file;
	gboolean valid;
	gint size, i;
	
	size = gtk_combo_box_get_active (box);
	gconf_client_set_int (client, "/apps/gset-compiz/preview", size, NULL);
	
	if (size == 0) size = 64;
	if (size == 1) size = 128;
	if (size == 2) size = 256;
	
	for (i=0; i<2; i++) {
	
		model = g_ptr_array_index (ptr, i);
		valid = gtk_tree_model_get_iter_first (model, &iter);

		while (valid) {		
			gtk_tree_model_get (model, &iter, 1, &file, -1);
			pixbuf = gdk_pixbuf_new_from_file_at_size (file, 
							      size, size, &err);
			gtk_list_store_set (GTK_LIST_STORE (model), &iter, 
								0, pixbuf, -1);
			
			if (pixbuf != NULL)
				g_object_unref (pixbuf);
			
			if (err != NULL) {
				file_error_handling (err);
				err = NULL;
			}
			valid = gtk_tree_model_iter_next (model, &iter);
		}
	}
	
	if (err != NULL)
		g_error_free (err);
}

void image_position_changed (GtkComboBox *box, GPtrArray *ptr)
{
	GtkWidget *widget = glade_xml_get_widget (xml, "slide_svgs");
	gint pos = gtk_combo_box_get_active (GTK_COMBO_BOX (box));

  	gtk_tree_view_set_model (GTK_TREE_VIEW (widget), 
  				 GTK_TREE_MODEL (g_ptr_array_index (ptr, pos)));
}

void slide_button_close (GtkButton *button, gpointer user_data)
{
	GtkWidget *slide = glade_xml_get_widget(xml, "Slide");
	gtk_widget_hide (slide);
}

void slide_delete (GtkWidget *widget, GdkEvent *event, gpointer data)
{
	gtk_widget_hide (widget);
}

/*	images file dialog callbacks		*/

void file_open (GtkButton *button, gpointer data)
{	
	GError *err = NULL;
	GtkWidget *widget;
	GtkTreeIter iter;
	GtkTreeModel *store;	
	GdkPixbuf *pixbuf;
	GSList *files;
	guint count, length, size, pos;
	gpointer f;
	
	widget = glade_xml_get_widget (xml, "slide_svgs");	
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (widget));

	widget = glade_xml_get_widget (xml, "Slide_file_dialog");
	gtk_widget_hide (widget);	
	files = gtk_file_chooser_get_filenames (GTK_FILE_CHOOSER (widget));	
	length = g_slist_length (files);
	
	widget = glade_xml_get_widget (xml, "slide_preview");
	size = gtk_combo_box_get_active (GTK_COMBO_BOX (widget));
	
	if (size == 0) size = 64;
	if (size == 1) size = 128;
	if (size == 2) size = 256;

	for (count=0; count<length; count++) {
		f = g_slist_nth_data (files, count); 
		pixbuf = gdk_pixbuf_new_from_file_at_size (f, size, size, &err);
		gtk_list_store_append (GTK_LIST_STORE (store), &iter);	
		gtk_list_store_set (GTK_LIST_STORE (store), &iter, 0, pixbuf, 
								   1, f, -1);
		if (pixbuf != NULL)
			g_object_unref (pixbuf);
	
		if (err != NULL) {
			file_error_handling (err);
			err = NULL;
		}
	}
	
	if (err != NULL)
		g_error_free (err);
	
	g_slist_free (files);
	
	widget = glade_xml_get_widget (xml, "image_position");
	pos = gtk_combo_box_get_active (GTK_COMBO_BOX (widget));
	
	set_image_store (GUINT_TO_POINTER (pos));
}

void file_cancel (GtkButton *button, gpointer user_data)
{
	GtkWidget *File = glade_xml_get_widget(xml, "Slide_file_dialog");
	gtk_widget_hide (File);
}

void file_delete (GtkWidget *widget, GdkEvent *event, gpointer data)
{
	gtk_widget_hide (widget);
}

/* 	thumbnail update	*/

void update_preview (GtkFileChooser *file_chooser, gpointer data)
{
  	GtkWidget *preview;
  	gchar *filename;
  	GdkPixbuf *pixbuf;
  	gboolean have_preview;

  	preview = GTK_WIDGET (data);
  	filename = gtk_file_chooser_get_preview_filename (file_chooser);
	
	if (filename) {
  		pixbuf = gdk_pixbuf_new_from_file_at_size (filename, 128, 128,
  									  NULL);
  		have_preview = (pixbuf != NULL);
  		gtk_image_set_from_pixbuf (GTK_IMAGE (preview), pixbuf);
  		
  		if (pixbuf)
    			gdk_pixbuf_unref (pixbuf);
  		
  		gtk_file_chooser_set_preview_widget_active (file_chooser,
  							    have_preview);
	}
}

/* 	trailfocus buttons	*/

void trail_add (GtkButton *button, gpointer user_data)
{
	select_X_window ();
}

void trail_remove (GtkButton *button, gpointer user_data)
{
	GtkTreeIter iter;
	gboolean valid;
	GtkWidget *view = glade_xml_get_widget (xml, "Trail_list");
	GtkTreeModel *store;
	GtkTreeSelection *selection;
	
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (view));
	selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (view));	
	valid = gtk_tree_selection_get_selected (selection, &store, &iter);
	
	if (valid) {
		gtk_list_store_remove (GTK_LIST_STORE (store), &iter);
		set_trailfocus_store ();
	}	
}

/* 	state plugin buttons		*/

void state_add (GtkButton *button, gpointer user_data)
{	
	GtkWidget *widget;	
	GtkTreeIter iter;	
	GtkTreeModel *store; 	
	gchar value[4], *check, *window, *fx;
	gint iV;
	gboolean valid;	
	
	widget = glade_xml_get_widget (xml, "State_type");
	window = gtk_combo_box_get_active_text (GTK_COMBO_BOX (widget));	
	
	widget = glade_xml_get_widget (xml, "State_attrib");
	fx = gtk_combo_box_get_active_text (GTK_COMBO_BOX (widget));
	
	widget = glade_xml_get_widget (xml, "State_value");
	iV = gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (widget));
	g_snprintf (value, 4, "%i", iV);		
	
	widget = glade_xml_get_widget (xml, "State_list");
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (widget));
	
	gtk_list_store_append (GTK_LIST_STORE (store), &iter);
	gtk_list_store_set (GTK_LIST_STORE (store), &iter, 0, fx,
							   1, window, 
							   2, value, -1);
	set_state_store ();
}

void state_remove (GtkButton *button, gpointer user_data)
{
	GtkTreeIter iter;
	gboolean valid;
	GtkWidget *view = glade_xml_get_widget (xml, "State_list");
	GtkTreeModel *store; 
	GtkTreeSelection *selection;
	
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (view));
	selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (view));
	valid = gtk_tree_selection_get_selected (selection, &store, &iter);
	
	if (valid) {
		gtk_list_store_remove (GTK_LIST_STORE (store), &iter);
		set_state_store ();
	}
}

/*	read/write gconf keys	   */

void get_gconf_keys (void)
{
  	GError *err = NULL;
	GConfValue *check;
	GtkFileFilter *filter;
	GtkWidget *widget, *preview;
	GdkColor color;
	GString *string;
	guint alpha;
	gchar *sValue, *path;	
	gint iValue;
	gfloat fValue;
	gboolean bValue;  	

	widget = glade_xml_get_widget (xml, ptr->name);
    	path = g_strdup_printf ("%s%s", ptr->dir, ptr->key);
	
	check = NULL;
	check = gconf_client_get (client, path, &err);
	if (check == NULL)
		return;
	
	switch (ptr->type) {
	
	case 0:	/*	spin button - int		*/
		iValue = gconf_client_get_int (client, path, &err);
		gtk_spin_button_set_value (GTK_SPIN_BUTTON (widget), iValue);
		break;
	  	
	case 1: /*	entry - string			*/
		sValue = gconf_client_get_string (client, path, &err);
		gtk_entry_set_text (GTK_ENTRY (widget), sValue);
		break;
	  	
	case 2: /*	hscale - float			*/
		fValue = gconf_client_get_float (client, path, &err);
		gtk_range_set_value (GTK_RANGE (widget), fValue);
		break;
	  	
	case 3: /*	checkbox			*/
		bValue = gconf_client_get_bool (client, path, &err);
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), 
								 bValue);
		break;
	  	
	case 4: /*	hscale - int			*/
		iValue = gconf_client_get_int (client, path, &err);
		gtk_range_set_value (GTK_RANGE (widget), iValue);
		break;
	  	
	case 5: /*   	wobbly window fx  		*/
		iValue = gconf_client_get_int (client, path, &err);
		if (iValue)
			gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON 
							(widget), TRUE);
	  	break;
		
	case 6:	/*	skydome image			*/		
		preview = gtk_image_new ();
		filter = gtk_file_filter_new ();
		sValue = gconf_client_get_string (client, path, &err);
		
		gtk_file_filter_add_pixbuf_formats (filter);		
		gtk_file_chooser_set_filter (GTK_FILE_CHOOSER (widget), filter);
		  		
  		gtk_file_chooser_set_preview_widget (GTK_FILE_CHOOSER 
  				    		(widget), GTK_WIDGET (preview));
  		g_signal_connect (GTK_FILE_CHOOSER_BUTTON (widget),
  						  "update-preview", G_CALLBACK 
  						  (update_preview), preview);
		if (strncmp (sValue, "", 1) != 0) {		
			sValue = check_file_path (sValue);
			gtk_file_chooser_set_filename (GTK_FILE_CHOOSER
						       	      (widget), sValue);
		}      	  
		break;
		
	case 7:	/*   	texture filter radio button   	*/
		sValue = gconf_client_get_string (client, path, &err);
		widget = glade_xml_get_widget (xml, sValue);
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
		break;
	
	case 8:	/*	cube color			*/
		sValue = gconf_client_get_string (client, path, &err);
		
		alpha = strtoul (&sValue[7], NULL, 16) * 256 + 127;
		gtk_color_button_set_alpha (GTK_COLOR_BUTTON (widget), alpha);
		
		string = g_string_new (sValue);
		string = g_string_truncate (string, 7);
		
		gdk_color_parse (string->str, &color);
		gtk_color_button_set_color (GTK_COLOR_BUTTON (widget), &color);
		
		g_string_free (string, TRUE);
		break;
	
	case 9:	/*	decoration shadow color		*/
		sValue = gconf_client_get_string (client, path, &err);		
		gdk_color_parse (sValue, &color);
		gtk_color_button_set_color (GTK_COLOR_BUTTON (widget), &color);
		break;
	
	case 10:/*	combo box			*/			
		iValue = gconf_client_get_int (client, path, &err);
		gtk_combo_box_set_active (GTK_COMBO_BOX (widget), iValue);
		break;	
	}
	
	g_free (path);
}

void set_gconf_keys (void)
{
  	GError *err = NULL;
	GConfValue *check;
	GdkColor color;
	guint red, green, blue, alpha;
	gchar *sValue, *path;
	const gchar *entry;
	gint iValue;
	gfloat fValue;
	gboolean bValue;  	

	GtkWidget *widget = glade_xml_get_widget (xml, ptr->name);
    	path = g_strdup_printf ("%s%s", ptr->dir, ptr->key);	
	
	check = NULL;
	check = gconf_client_get (client, path, &err);
	if (check == NULL)
		return;	
	
	switch (ptr->type) {
		
	case 0:	
		iValue = gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON
							   	  (widget));
		gconf_client_set_int (client, path, iValue, &err);
		break;
	
	case 1:
		entry = gtk_entry_get_text (GTK_ENTRY (widget));
		gconf_client_set_string (client, path, entry, &err);
		break;
	
	case 2:
		fValue = gtk_range_get_value (GTK_RANGE (widget));
		gconf_client_set_float (client, path, fValue, &err);
		break;
	
	case 3:
		bValue = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON 
								(widget));
		gconf_client_set_bool (client, path, bValue, &err);
		break;
	
	case 4:
		iValue = gtk_range_get_value (GTK_RANGE (widget));
		gconf_client_set_int (client, path, iValue, &err);
		break;
	
	case 5:
	  	bValue = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON 
								(widget));
		if (bValue) 
			sValue = "Shiver";
		else
			sValue = "None";
		
		gconf_client_set_string (client, path, sValue, &err);
	  	break;

	case 6:	
		sValue = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER 
								(widget));
	  	if (sValue)
	  		gconf_client_set_string (client, path, sValue, &err);
		
		break;
	
	case 7:
		bValue = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON 
								(widget));
		if (bValue)
			gconf_client_set_string (client, path, ptr->name, &err);
		break;
	
	case 8:
		gtk_color_button_get_color (GTK_COLOR_BUTTON (widget), &color);
		alpha = gtk_color_button_get_alpha (GTK_COLOR_BUTTON (widget));
		
		red = color.red / 256;
		green = color.green / 256;
		blue = color.blue / 256;
		alpha /= 256;
		sValue = g_strdup_printf ("#%02x%02x%02x%02x", red, green, blue, 
									alpha);
		gconf_client_set_string (client, path, sValue, &err);
		break;
	
	case 9:
		gtk_color_button_get_color (GTK_COLOR_BUTTON (widget), &color);
		
		red = color.red / 256;
		green = color.green / 256;
		blue = color.blue / 256;

		sValue = g_strdup_printf ("#%02x%02x%02x", red, green, blue);
		gconf_client_set_string (client, path, sValue, &err);
		break;
	
	case 10:
		iValue = gtk_combo_box_get_active (GTK_COMBO_BOX (widget));
		gconf_client_set_int (client, path, iValue, &err);
		break;
	}
	
	g_free (path);
}

gchar *check_file_path (gchar *file)
{
	GString *string = g_string_new (file);
	
	if (strncmp (&file[0], "/", 1) != 0) {

		string = g_string_prepend (string, "/");
		string = g_string_prepend (string, DEF_IMAGE_FOLDER);
		file = string->str;
	}
	
	g_string_free (string, FALSE);
	
	return file;
}

/*	generate active plugins list	*/

void active_plugins (void)
{	
	enum {COLUMN_BOOLEAN, COLUMN_STRING, N_COLUMNS};

  	GtkListStore *store;
  	GtkTreeViewColumn *column;
  	GtkCellRenderer *renderer;
	GtkWidget *list = glade_xml_get_widget (xml, "active");

	store = gtk_list_store_new (N_COLUMNS, G_TYPE_BOOLEAN,
  					       G_TYPE_STRING);
	active_plugins_store (store);
    	gtk_tree_view_set_model (GTK_TREE_VIEW (list), GTK_TREE_MODEL (store));
    	g_object_unref (G_OBJECT (store));  	
   	
   	renderer = gtk_cell_renderer_toggle_new ();
   	column = gtk_tree_view_column_new_with_attributes ("Active",
        					renderer, "active",
						COLUMN_BOOLEAN, NULL);
   	gtk_tree_view_append_column (GTK_TREE_VIEW (list), column);
	g_signal_connect (renderer, "toggled", (GCallback) plugins_toggled, 
					       GTK_TREE_MODEL (store));		
	renderer = gtk_cell_renderer_text_new ();
   	column = gtk_tree_view_column_new_with_attributes ("Plugin",
   						renderer, "text", 
   						COLUMN_STRING, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (list), column);

	set_sensitivity ();
}

/*	search fs for plugins and convert the filenames to 
	'plugin names', then check gconf if they are enabled 		*/

GtkTreeModel *active_plugins_store (GtkListStore *store)
{	
	GError *err = NULL;
  	GtkTreeIter iter;
	GDir *lib;
	GString *string;
	GSList *plugins, *fs = NULL;
  	gchar *path;       	
      	guint len_fs, len_plugins, i, count;
      	gboolean present;
  	
	gtk_list_store_clear (store);

	lib = g_dir_open (LIB_PATH, 0, NULL);	

	if (lib == NULL) {
		g_error ("Plugin directory not found, exiting...\n");
		gtk_main_quit;
	}
	
	const gchar *name = "";
	while (name != NULL) {				
		name = g_dir_read_name (lib);
		
		if (name != NULL)			
			present = g_str_has_suffix (name, ".so");
		
		if (present) {
			string = g_string_new (name);
			string = g_string_erase (string, 0, 3);
			string = g_string_truncate (string, string->len - 3);
			fs = g_slist_append (fs, g_string_free (string, FALSE));
			present = FALSE;
		}		
	}
	g_dir_close (lib); 	

  	fs = g_slist_sort (fs, (GCompareFunc) compare);	
  	
  	path = g_strdup_printf("%sactive_plugins", GEN_ALL_KEYS);
	plugins = gconf_client_get_list (client, path, GCONF_VALUE_STRING, 
									&err);
  	g_free (path);
      	
      	len_plugins = g_slist_length (plugins);
	len_fs = g_slist_length (fs);
      	
      	for (count=0; count<len_fs; count++) {
		present = FALSE;
		gpointer fs_ptr = g_slist_nth_data (fs, count);
		
		for (i=0; i<len_plugins; i++) {
			gpointer data = g_slist_nth_data (plugins, i);
			if (strncmp (data, fs_ptr, 12) == 0)
				present = TRUE;				
		}      		
      		gtk_list_store_append (store, &iter);
      		gtk_list_store_set (store, &iter, 0, present, 1, fs_ptr, -1);
    	}	
    	
    	g_slist_free (plugins);
	g_slist_free (fs);
	
	return GTK_TREE_MODEL (store);
}

/*	update active plugins list in gconf	*/

void set_active_plugins (void)
{
	GError *err = NULL;
	GtkTreeIter iter;
	GtkTreeModel *store;
	GtkWidget *list = glade_xml_get_widget (xml, "active");
	GSList *plugins = NULL;
	gchar *path, *name;
	gboolean state, valid;
	
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (list));
	valid = gtk_tree_model_get_iter_first (store, &iter);
	
	while (valid) {	
		gtk_tree_model_get (store, &iter, 0, &state, 1, &name, -1);

		if (state == TRUE)
			plugins = g_slist_append (plugins, name);
		
		valid = gtk_tree_model_iter_next (store, &iter);		
	}
	
	path = g_strdup_printf ("%sactive_plugins",GEN_ALL_KEYS);	
	gconf_client_set_list (client, path, GCONF_VALUE_STRING, plugins, &err);

	g_slist_free (plugins);
  	g_free (path);
}

/* 	comparison function to sort plugins 		*/

gint *compare (gconstpointer a, gconstpointer b)
{
	gint x, y, value;
	const gchar *order[] = {		
	"gconf", "miniwin", "decoration", "dock", "wobbly", "fade", "minimize",
	"cube", "rotate", "zoom", "scale", "move", "resize", "place", "state",
	"switcher", "trailfocus", "water", "bs", "OTHER"};
	
	for (x=0; x<20; x++) {		 	
		if (strncmp (a, order[x], 12) == 0)
			break;
	}

	for (y=0; y<20; y++) {		 	
		if (strncmp (b, order[y], 12) == 0)
			break;
	}
	
	if (x < y) 
		value = -1;
	if (x > y) 
		value = 1;
	if (x == y)
		value = 0;
	
	return GINT_TO_POINTER (value);
}

/* 	creates the fx selection list for the wobbly tab	*/

void wobbly_fx_types (void)
{	
  	enum {COLUMN_STRING, COLUMN_GRAB, 
      	      COLUMN_MAP, COLUMN_MOVE, COLUMN_FOCUS,
      	      N_COLUMNS};
  	
  	GtkListStore *store;
  	GtkTreeViewColumn *column;
  	GtkCellRenderer *renderer;
	GtkWidget *list = glade_xml_get_widget (xml,"Wobbly_types");
	
	store = gtk_list_store_new (N_COLUMNS, G_TYPE_STRING,
					       G_TYPE_BOOLEAN, 
  					       G_TYPE_BOOLEAN,
  					       G_TYPE_BOOLEAN,
  					       G_TYPE_BOOLEAN);	
	populate_wobbly_fx (store);
    	gtk_tree_view_set_model (GTK_TREE_VIEW (list), GTK_TREE_MODEL (store));
    	g_object_unref (G_OBJECT (store));
  	
   	renderer = gtk_cell_renderer_text_new ();
   	column = gtk_tree_view_column_new_with_attributes ("Type",
   							renderer, "text", 
   							COLUMN_STRING, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW(list), column);
       	
       	
       	renderer = gtk_cell_renderer_toggle_new();   	
   	column = gtk_tree_view_column_new_with_attributes ("Grab",
        						renderer, "active",
							COLUMN_GRAB, NULL);
   	gtk_tree_view_append_column (GTK_TREE_VIEW(list), column);
	g_signal_connect (renderer, "toggled", (GCallback) wobbly_toggled, 
						GINT_TO_POINTER (COLUMN_GRAB));	
	
	renderer = gtk_cell_renderer_toggle_new();   	
   	column = gtk_tree_view_column_new_with_attributes ("Map",
        						renderer, "active",
							COLUMN_MAP, NULL);
   	gtk_tree_view_append_column (GTK_TREE_VIEW(list), column);
	g_signal_connect (renderer, "toggled", (GCallback) wobbly_toggled, 
						GINT_TO_POINTER (COLUMN_MAP));	
	
	renderer = gtk_cell_renderer_toggle_new();   	
   	column = gtk_tree_view_column_new_with_attributes ("Move",
        						renderer, "active",
							COLUMN_MOVE, NULL);
   	gtk_tree_view_append_column (GTK_TREE_VIEW(list), column);
	g_signal_connect (renderer, "toggled", (GCallback) wobbly_toggled, 
						GINT_TO_POINTER (COLUMN_MOVE));
	
	renderer = gtk_cell_renderer_toggle_new();
   	column = gtk_tree_view_column_new_with_attributes ("Focus",
        						renderer, "active",
							COLUMN_FOCUS, NULL);
   	gtk_tree_view_append_column (GTK_TREE_VIEW(list), column);
	g_signal_connect (renderer, "toggled", (GCallback) wobbly_toggled, 
						GINT_TO_POINTER (COLUMN_FOCUS));
}

/*	reads gconf keys and populate the store for the wobbly fx list	*/

GtkTreeModel *populate_wobbly_fx (GtkListStore *store) 
{	
	GError *err = NULL;
	GtkTreeIter iter;
	GSList *windows;
	gchar *path;
	gint e_count, c_count;
	guint length, i;
	gboolean present;
      	gchar *entry[] = {"Normal", "Dialog", "Utility", "Menu", "Toolbar",
      		   	  "Splash", "ModalDialog", "Dock", "Desktop", 
      		   	  "Fullscreen", "Unknown"};
	gchar *keys[] = {"grab_window_types", "map_window_types", 
		  	 "move_window_types", "focus_window_types"};
	                               	
	for (e_count=0; e_count < 11; e_count++) {
		gtk_list_store_append (store, &iter);
		gtk_list_store_set (store, &iter, 0, entry[e_count], -1);
		
		for (c_count=0; c_count < 4; c_count++) {		
			present = FALSE;
			path = g_strdup_printf ("%s%s", WOBBLY_KEYS, 
							keys[c_count]);
  			windows = gconf_client_get_list (client, path,
  						GCONF_VALUE_STRING, &err);
			length = g_slist_length (windows);
			
			for (i=0; i < length; i++) {
				gpointer data = g_slist_nth_data (windows, i);
				if (strncmp (data, entry[e_count], 12) == 0)
					present = TRUE;
			}
			
			gtk_list_store_set (store, &iter, c_count+1,
								present, -1);
		}
    	}
	
	g_free (path);
	g_slist_free (windows);
	
	return GTK_TREE_MODEL (store);
}

/* 	update wobbly window_types lists in gconf	*/

void set_wobbly_fx (void)
{
	GConfValue *check = NULL;
	GError *err = NULL;
	GtkTreeIter iter;
	GtkTreeModel *store;
	GtkWidget *list = glade_xml_get_widget (xml, "Wobbly_types");
	gchar *path, *name;
	gint count;
	gboolean state, valid;
	gchar *keys[] = {"grab_window_types", "map_window_types", 
		  	 "move_window_types", "focus_window_types"};
	
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (list));
	
	for (count=0; count<4; count++) {
		GSList *window = NULL;
		valid = gtk_tree_model_get_iter_first (store, &iter);
		
		while (valid) {	
			gtk_tree_model_get (store, &iter, 0, &name,
				            		  count+1, &state, -1);
			if (state == TRUE)
				window = g_slist_append (window, name);
			valid = gtk_tree_model_iter_next (store, &iter);	
		}
		path = g_strdup_printf ("%s%s", WOBBLY_KEYS, keys[count]);
		
		check = gconf_client_get (client, path, &err);
		if (check != NULL)
			gconf_client_set_list (client, path, GCONF_VALUE_STRING,
							       window, &err);
		g_slist_free (window);
	}		

  	g_free (path);
}

/*	create window_type lists for all plugins	*/

void choose_window_types (void)
{
	enum {COLUMN_STRING, COLUMN_ACTIVE};
  	
 	GtkListStore *store;
 	GtkTreeViewColumn *column;
  	GtkCellRenderer *renderer;
	GtkWidget *list = glade_xml_get_widget (xml, ptr->name);
	
    	store = gtk_list_store_new (2, G_TYPE_STRING,
  				       G_TYPE_BOOLEAN);
  	create_window_store (store);
    	gtk_tree_view_set_model (GTK_TREE_VIEW(list), GTK_TREE_MODEL (store));
    	g_object_unref (G_OBJECT(store));
  	
   	renderer = gtk_cell_renderer_text_new ();
   	column = gtk_tree_view_column_new_with_attributes ("Type",
   						renderer, "text", 
   						COLUMN_STRING, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW(list), column);
       	renderer = gtk_cell_renderer_toggle_new();   	
   	column = gtk_tree_view_column_new_with_attributes ("Active",
        					renderer, "active",
						COLUMN_ACTIVE, NULL);
   	gtk_tree_view_append_column (GTK_TREE_VIEW(list), column);
	g_signal_connect (renderer, "toggled", (GCallback) window_types_toggled, 
					       GTK_TREE_VIEW (list));
}

/*	populates liststores for choose_window_types		*/

GtkTreeModel *create_window_store (GtkListStore *store)
{
	GError *err = NULL;
	GtkTreeIter iter;
	GSList *w;
	guint length, count, i;
	gboolean present;
	gchar *path;
	gchar *entry[] = {"Normal", "Dialog", "Utility", "Menu", "Toolbar",
      		   	  "Splash", "ModalDialog", "Dock", "Desktop", 
      		   	  "Fullscreen", "Unknown"};	
		
	path = g_strdup_printf ("%s%s", ptr->dir, ptr->key);
	w = gconf_client_get_list (client, path, GCONF_VALUE_STRING, &err);
	g_free (path);					
	
	length = g_slist_length (w);
	for (count=0; count<11; count++) {
		present = FALSE;
		
		for (i=0; i<length; i++) {
			gpointer data = g_slist_nth_data (w, i);
			if (strncmp (data, entry[count], 12) == 0)
				present = TRUE;					
		}		
		
		gtk_list_store_append (store, &iter);
		gtk_list_store_set (store, &iter, 0, entry[count], 
						  1, present, -1);	
	}
	
	g_slist_free (w);
	
	return GTK_TREE_MODEL (store);
}

/* 	write window_types keys to gconf	*/
 
void set_window_store (void)
{	
	GConfValue *check = NULL;
	GError *err = NULL;
	GtkTreeIter iter;
	GtkTreeModel *store;
	GtkWidget *list = glade_xml_get_widget (xml, ptr->name);
	gchar *path, *name;
	gboolean state, valid;
	GSList *window = NULL;
	
	path = g_strdup_printf ("%s%s", ptr->dir, ptr->key);
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (list));
	valid = gtk_tree_model_get_iter_first (store, &iter);
		
	while (valid) {	
		gtk_tree_model_get (store, &iter, 0, &name,
						  1, &state, -1);
		if (state == TRUE)
			window = g_slist_append (window, name);
		valid = gtk_tree_model_iter_next (store, &iter);	
	}	
	
	check = gconf_client_get (client, path, &err);
	if (check != NULL)
		gconf_client_set_list (client, path, GCONF_VALUE_STRING, 
								window, &err);	

	g_slist_free (window);
  	g_free (path); 	 	
	g_free (name);
}

/*	treeview for hot corners of scale plugin	*/

void choose_corner_list (void)
{
	enum {COLUMN_STRING, COLUMN_ALL, COLUMN_CURRENT, 
				COLUMN_SCREEN, N_COLUMNS};
  	
 	GtkListStore *store;
 	GtkTreeViewColumn *column;
  	GtkCellRenderer *renderer;
	GtkWidget *list = glade_xml_get_widget (xml, "Scale_corners");
	
    	store = gtk_list_store_new (N_COLUMNS, G_TYPE_STRING,
  					       G_TYPE_BOOLEAN,
  					       G_TYPE_BOOLEAN,
  					       G_TYPE_BOOLEAN);
    	
    	create_corner_store (store);
    	gtk_tree_view_set_model (GTK_TREE_VIEW (list), GTK_TREE_MODEL (store));
    	g_object_unref (G_OBJECT (store));
  	
   	renderer = gtk_cell_renderer_text_new ();
   	column = gtk_tree_view_column_new_with_attributes ("Position", renderer, 
   					 	"text", COLUMN_STRING, NULL);
	g_object_set (column, "sizing", GTK_TREE_VIEW_COLUMN_FIXED,
   			      "fixed-width", 110, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (list), column);
       	
       	renderer = gtk_cell_renderer_toggle_new ();   	
   	column = gtk_tree_view_column_new_with_attributes ("All",
   						renderer, 
   						"active", COLUMN_ALL, NULL);
   	gtk_tree_view_append_column (GTK_TREE_VIEW (list), column);
	g_signal_connect (renderer, "toggled", (GCallback) corner_toggled, 
					       GINT_TO_POINTER (COLUMN_ALL));	
	
	renderer = gtk_cell_renderer_toggle_new();   	
   	column = gtk_tree_view_column_new_with_attributes ("Screen",
   						renderer, 
   						"active", COLUMN_CURRENT, NULL);
   	gtk_tree_view_append_column (GTK_TREE_VIEW(list), column);
	g_signal_connect (renderer, "toggled", (GCallback)
			corner_toggled, GINT_TO_POINTER (COLUMN_CURRENT));
								
	renderer = gtk_cell_renderer_toggle_new();   	
   	column = gtk_tree_view_column_new_with_attributes ("App", 
   						renderer, 
   						"active", COLUMN_SCREEN, NULL);
   	gtk_tree_view_append_column (GTK_TREE_VIEW(list), column);
	g_signal_connect (renderer, "toggled", (GCallback)
			corner_toggled, GINT_TO_POINTER (COLUMN_SCREEN));	
}

GtkTreeModel *create_corner_store (GtkListStore *store)
{	
	GError *err = NULL;
	GtkTreeIter iter;
	GSList *corners;
	guint length, e_count, c_count, i;
	gboolean present;
	gchar *path;
	gchar *entry[] = {"TopLeft", "TopRight", "BottomLeft", "BottomRight"};	
	gchar *keys[] = {"corners", "current_corners", "all_screens_corners"};
                              	
	for (e_count=0; e_count<4; e_count++) {
		gtk_list_store_append (store, &iter);
		gtk_list_store_set (store, &iter, 0, entry[e_count], -1);
		
		for (c_count=0; c_count < 3; c_count++) {		
			present = FALSE;
			path = g_strdup_printf ("%s%s", SCALE_KEYS, 
							keys[c_count]);
  			corners = gconf_client_get_list (client, path,
  						GCONF_VALUE_STRING, &err);
			length = g_slist_length (corners);
			
			for (i=0; i < length; i++) {
				gpointer data = g_slist_nth_data (corners, i);
				if (strncmp (data, entry[e_count], 14) == 0)
					present = TRUE;
			}
			gtk_list_store_set (store, &iter, c_count+1,
								present, -1);
		}
    	}

	g_free (path);
	g_slist_free (corners);
	
	return GTK_TREE_MODEL (store);
}

void set_corner_store (void)
{
	GConfValue *check = NULL;
	GError *err = NULL;
	GtkTreeIter iter;
	GtkTreeModel *store;
	GtkWidget *list = glade_xml_get_widget (xml, "Scale_corners");
	gchar *path, *name;
	gint count;
	gboolean state, valid;
	gchar *keys[] = {"corners", "current_corners", "all_screens_corners"};
	
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (list));
	
	for (count=0; count<3; count++) {
		GSList *corners = NULL;
		valid = gtk_tree_model_get_iter_first (store, &iter);
		
		while (valid) {	
			gtk_tree_model_get (store, &iter, 0, &name,
				            		  count+1, &state, -1);
			if (state == TRUE)
				corners = g_slist_append (corners, name);
			valid = gtk_tree_model_iter_next (store, &iter);	
		}
		
		path = g_strdup_printf ("%s%s", SCALE_KEYS, keys[count]);
		
		check = NULL;
		check = gconf_client_get (client, path, &err);
		
		if (check != NULL)
			gconf_client_set_list (client, path, GCONF_VALUE_STRING,
							       corners, &err);
		g_slist_free (corners);
	}		

  	g_free (path); 	 	
}

/*	treeview for sildes window	*/

void images_list (void)
{
 	GtkTreeViewColumn *column;
  	GtkCellRenderer *renderer;
	GtkWidget *list = glade_xml_get_widget (xml, "slide_svgs");
   	
   	renderer = gtk_cell_renderer_pixbuf_new ();
   	column = gtk_tree_view_column_new_with_attributes ("Preview", renderer, 
   							   "pixbuf", 0,
   							   NULL);
	g_object_set (column, "sizing", GTK_TREE_VIEW_COLUMN_AUTOSIZE, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (list), column);       	
       	
       	renderer = gtk_cell_renderer_text_new();   	
	column = gtk_tree_view_column_new_with_attributes ("File", renderer,
							   "text", 1,
							   NULL);
   	gtk_tree_view_append_column (GTK_TREE_VIEW (list), column);
}

GtkTreeModel *create_top_image_store (void)
{
	GtkWidget *widget;
	GError *err = NULL;
	GtkListStore *store;
	GtkTreeIter iter;
	GSList *slides;
	guint length, count, id = 0;
	gpointer file;
	gchar *path;
        gboolean version;
        
        store = gtk_list_store_new (2, GDK_TYPE_PIXBUF, G_TYPE_STRING);        
        
        widget = glade_xml_get_widget (xml, "menu_version");
	version = gtk_check_menu_item_get_active (GTK_CHECK_MENU_ITEM (widget));

	if (version)
        	path = g_strdup_printf ("%simages_top", CUBE_KEYS);
        else
		path = g_strdup_printf ("%simages", CUBE_KEYS);
        
        slides = gconf_client_get_list (client, path, GCONF_VALUE_STRING, &err);
        length = g_slist_length (slides);                     	
	
	for (count=0; count<length; count++) {
		file = g_slist_nth_data (slides, count);
    		file = check_file_path (file);
    		gtk_list_store_append (store, &iter);
    		gtk_list_store_set (store, &iter, 1, file, -1);
    	}

	g_free (path);
	g_slist_free (slides);
	
	g_signal_connect (store, "row-deleted",
			  G_CALLBACK (slide_row_delete), GUINT_TO_POINTER (id));
        g_signal_connect (store, "rows-reordered",
        		 G_CALLBACK (slide_row_reorder), GUINT_TO_POINTER (id));
	
	return GTK_TREE_MODEL (store);
}

GtkTreeModel *create_bottom_image_store (void)
{
	GError *err = NULL;
	GtkListStore *store;
	GtkTreeIter iter;
	GSList *slides;
	guint length, count, id = 1;
	gchar *path;
	gpointer file;
	
	store = gtk_list_store_new (2, GDK_TYPE_PIXBUF, G_TYPE_STRING);

        path = g_strdup_printf ("%simages_bottom", CUBE_KEYS);	
        slides = gconf_client_get_list (client, path, GCONF_VALUE_STRING, &err);

        length = g_slist_length (slides);                     	
	for (count=0; count<length; count++) {		
		file = g_slist_nth_data (slides, count);
    		file = check_file_path (file);
    		gtk_list_store_append (store, &iter);
    		gtk_list_store_set (store, &iter, 1, file, -1);
    	}
	
	g_free (path);
	g_slist_free (slides);
	
	g_signal_connect (store, "row-deleted", 
			  G_CALLBACK (slide_row_delete), GUINT_TO_POINTER (id));
        g_signal_connect (store, "rows-reordered", 
        		 G_CALLBACK (slide_row_reorder), GUINT_TO_POINTER (id));
	
	return GTK_TREE_MODEL (store);
}

void set_image_store (guint *pos)
{
	GConfValue *check = NULL;
	GError *err = NULL;
	GtkTreeIter iter;
	GtkTreeModel *store;
	GtkWidget *widget = glade_xml_get_widget (xml, "slide_svgs");
	gchar *path, *name, *key[] = {"images_top", "images_bottom"};
	gboolean valid, version;
	GSList *slides = NULL;
			
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (widget));
	valid = gtk_tree_model_get_iter_first (store, &iter);
		
	while (valid) {	
		
		gtk_tree_model_get (store, &iter, 1, &name, -1);
		slides = g_slist_append (slides, name);
		valid = gtk_tree_model_iter_next (store, &iter);	
	}	
	
	widget = glade_xml_get_widget (xml, "menu_version");
	version = gtk_check_menu_item_get_active (GTK_CHECK_MENU_ITEM(widget));
	
	if (version)
		path = g_strdup_printf ("%s%s", CUBE_KEYS, 
					key[GPOINTER_TO_UINT (pos)]);
	else
		path = g_strdup_printf ("%s%s", CUBE_KEYS, "images");
	
	check = gconf_client_get (client, path, &err);
	
	if (check != NULL) {
		gconf_client_set_list (client, path, GCONF_VALUE_STRING, 
								slides, &err);
		gconf_value_free (check);
	}
	
	g_slist_free (slides);
  	g_free (path);
}

/* 	set sensitivity of pluging tabs and shortcut expanders 
	according to the active plugings list.    			*/
	
void set_sensitivity (void)
{
	GtkTreeIter iter;
	gboolean valid, state, open;
	gchar *name, *label;
	
	GtkWidget *widget = glade_xml_get_widget (xml, "active");
	GtkTreeModel *store = gtk_tree_view_get_model (GTK_TREE_VIEW (widget));
	valid = gtk_tree_model_get_iter_first (store, &iter);	
	
	while (valid) {		
			
		gtk_tree_model_get (store, &iter, 0, &state, 1, &name, -1);
		widget = glade_xml_get_widget (xml, name);
			
		if (widget != NULL)
			gtk_widget_set_sensitive (GTK_WIDGET (widget), state);
			
		label = g_strdup_printf ("%s_l", name);
		widget = glade_xml_get_widget (xml, label);
			
		if (widget != NULL)
			gtk_widget_set_sensitive (widget, state);	

		label = g_strdup_printf ("%s_shorts", name);
		widget = glade_xml_get_widget (xml, label);
			
		if (widget != NULL) {				
			open = gtk_expander_get_expanded (GTK_EXPANDER(widget));
			if (open)
				gtk_expander_set_expanded (GTK_EXPANDER(widget),
							   !open);
			gtk_widget_set_sensitive (GTK_WIDGET (widget), state);
		}	
		
		valid = gtk_tree_model_iter_next (store, &iter);	
	}
	
	g_free (label);
}

/*	X cursor to select windows	*/

void select_X_window (void)
{
	GdkCursor *cursor;
	GdkWindow *window = gdk_get_default_root_window ();	
	GtkWidget *widget = glade_xml_get_widget (xml, "Trail_list");
	
	cursor = gdk_cursor_new (GDK_X_CURSOR);	
	gtk_widget_add_events (widget, GDK_BUTTON_PRESS_MASK);
	gdk_window_add_filter (window, (GdkFilterFunc) filter, widget);	
	
	gdk_pointer_grab (window, FALSE, GDK_BUTTON_PRESS_MASK, NULL, 
			  cursor, GDK_CURRENT_TIME);	
	gdk_cursor_unref (cursor);	
}

/*  	convert x events to gdk events
    	and query x windows for their names		*/

GdkFilterReturn filter (GdkXEvent *gdk_xevent, GdkEvent *event, 
					       GtkWidget *widget)
{	
	Display *display = XOpenDisplay (NULL);
	XClassHint *class = XAllocClassHint ();	
	
	XEvent *xevent = (XEvent *) gdk_xevent;
	XButtonEvent *button = &xevent->xbutton;
	Window w = button->subwindow;

	XGetClassHint (display, w, class);
		
	set_wm_class (class->res_class, widget);
	
	XFree (class);
	
	gdk_pointer_ungrab (GDK_CURRENT_TIME);
	gdk_window_remove_filter (gdk_get_default_root_window (),
				  (GdkFilterFunc) filter, widget);
	
	return GDK_FILTER_REMOVE;
}

/* 	write wm_class name to widget	*/

void set_wm_class (gchar *class, GtkWidget *widget)
{		
	if (class == NULL)
		return;

	GtkTreeIter iter;		
	gboolean valid;
	gchar *check;
		
	GtkTreeModel *store = gtk_tree_view_get_model (GTK_TREE_VIEW (widget));
	valid = gtk_tree_model_get_iter_first (store, &iter);
		
	while (valid) {
		gtk_tree_model_get (store, &iter, 0, &check, -1);
		
		if (strncmp (class, check, 12) == 0) {
			g_free (check);
			return;
		}
		
		valid = gtk_tree_model_iter_next (store, &iter);
	}
		
	gtk_list_store_append (GTK_LIST_STORE(store), &iter);	
	gtk_list_store_set (GTK_LIST_STORE(store), &iter, 0, class, -1);
		
	set_trailfocus_store ();		
}

/* 	the trailfocus plugin treeview	*/

void trailfocus_list (void)
{  	
 	GtkListStore *store;
 	GtkTreeViewColumn *column;
  	GtkCellRenderer *renderer;
	GtkWidget *list = glade_xml_get_widget (xml, "Trail_list");
    	
    	store = gtk_list_store_new (1, G_TYPE_STRING);
	
	create_trailfocus_store (store);
    	gtk_tree_view_set_model (GTK_TREE_VIEW (list), GTK_TREE_MODEL (store));
   	g_object_unref (G_OBJECT (store));
   	
   	renderer = gtk_cell_renderer_text_new();   	
	column = gtk_tree_view_column_new_with_attributes ("", renderer,
							   "text", 0, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (list), column);       	
}

GtkTreeModel *create_trailfocus_store (GtkListStore *store)
{
	
	GError *err = NULL;
	GtkTreeIter iter;
	GSList *apps;
	guint length, count;
	gchar *path;

        path = g_strdup_printf ("%sexclude", TRAIL_KEYS);
        apps = gconf_client_get_list (client, path, GCONF_VALUE_STRING, &err);
        
        length = g_slist_length (apps);                     	
	
	for (count=0; count<length; count++) {
		gtk_list_store_append (store, &iter);
		gpointer data = g_slist_nth_data (apps, count);
		gtk_list_store_set (store, &iter, 0, data, -1);
    	}
	
	g_free (path);
	g_slist_free (apps);

	return GTK_TREE_MODEL (store);
}

void set_trailfocus_store (void)
{
	GConfValue *check = NULL;
	GError *err = NULL;
	GtkTreeIter iter;
	GtkTreeModel *store;
	GtkWidget *list = glade_xml_get_widget (xml, "Trail_list");
	gchar *path, *name;
	gboolean valid;
	GSList *apps = NULL;
	
	path = g_strdup_printf ("%sexclude", TRAIL_KEYS);
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (list));
	valid = gtk_tree_model_get_iter_first (store, &iter);
		
	while (valid) {	
		gtk_tree_model_get (store, &iter, 0, &name, -1);
		apps = g_slist_append (apps, name);
		valid = gtk_tree_model_iter_next (store, &iter);	
	}	
	
	check = gconf_client_get (client, path, &err);
	if (check != NULL) {
		gconf_client_set_list (client, path, GCONF_VALUE_STRING, 
								apps, &err);
		gconf_value_free (check);
	}
	
	g_slist_free (apps);
  	g_free (path);
}

void state_list (void)
{  	
 	GtkListStore *store;
 	GtkTreeViewColumn *column;
  	GtkCellRenderer *renderer;
	GtkWidget *list = glade_xml_get_widget (xml, "State_list");
    	
    	store = gtk_list_store_new (3, G_TYPE_STRING,
  				       G_TYPE_STRING,
  				       G_TYPE_STRING);
	
	create_state_store (store);
    	gtk_tree_view_set_model (GTK_TREE_VIEW (list), GTK_TREE_MODEL (store));
   	g_object_unref (G_OBJECT (store));
   	
   	renderer = gtk_cell_renderer_text_new();   	
	column = gtk_tree_view_column_new_with_attributes ("Effekt",
							   renderer,
							   "text", 0, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (list), column);
	
   	renderer = gtk_cell_renderer_text_new();   	
	column = gtk_tree_view_column_new_with_attributes ("Window type",
							   renderer,
							   "text", 1, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (list), column);       	
       	
       	renderer = gtk_cell_renderer_text_new();   	
	column = gtk_tree_view_column_new_with_attributes ("Value",
							   renderer,
							   "text", 2, NULL);
   	gtk_tree_view_append_column (GTK_TREE_VIEW (list), column);
}

GtkTreeModel *create_state_store (GtkListStore *store)
{	
	GError *err = NULL;
	GtkTreeIter iter;
	GSList *apps;
	guint length, count, i;
	gchar *path, **list;
	
	const gchar *key[] = {"brightness", "saturation", "opacity"};
        
        for (i=0; i<3; i++) {
        
        	path = g_strdup_printf ("%s%s", STATE_KEYS, key[i]);
        	apps = gconf_client_get_list (client, path, 
        					GCONF_VALUE_STRING, &err);
                    	
		for (count=0; count<(g_slist_length (apps)); count++) {		
			gpointer data = g_slist_nth_data (apps, count);
			list = g_strsplit (data, ":", 3);
			gtk_list_store_append (store, &iter);
			gtk_list_store_set (store, &iter, 0, key[i],
						  	  1, list[1],
						  	  2, list[2], -1);
    			g_strfreev (list);
    		}
	}
	g_free (path);	
	g_slist_free (apps);

	return GTK_TREE_MODEL (store);
}

void set_state_store (void)
{
	GConfValue *check = NULL;
	GError *err = NULL;
	GtkTreeIter iter;
	GtkTreeModel *store;
	GtkWidget *list = glade_xml_get_widget (xml, "State_list");
	gchar *path, *type, *value, *string, *key_list;
	gboolean valid;
	GSList *apps = NULL;
	guint i;
	const gchar *key[] = {"brightness", "saturation", "opacity"};
	
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (list));

	for (i=0; i<3; i++) {
		valid = gtk_tree_model_get_iter_first (store, &iter);

		while (valid) {	
			gtk_tree_model_get (store, &iter, 0, &key_list, 
						  	  1, &type,
						  	  2, &value, -1);
			if (strncmp (key_list, key[i], 10) == 0) {
				string = g_strjoin (":", "w", type, value,
									 NULL);
				apps = g_slist_append (apps, string);

			}
			valid = gtk_tree_model_iter_next (store, &iter);
		}
	
		path = g_strdup_printf ("%s%s", STATE_KEYS, key[i]);
		
		check = gconf_client_get (client, path, &err);
		if (check != NULL) {		
			gconf_client_set_list (client, path, 
						GCONF_VALUE_STRING, apps, &err); 
			gconf_value_free (check);
		}
		apps = NULL;
	}
	
	g_slist_free (apps);
  	g_free (path);
}

/* 	display a popup for gconf errors	*/

void *gconf_error_handling (GConfClient *c, GError *err)
{
	GtkWidget *dialog, *main;

	main = glade_xml_get_widget (xml, "Main");	
	dialog = gtk_message_dialog_new (GTK_WINDOW (main), 
					 GTK_DIALOG_DESTROY_WITH_PARENT,
                                  	 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                                  	 "GConf-Error\n\n%s", err->message); 	
 	gtk_dialog_run (GTK_DIALOG (dialog));
 	gtk_widget_destroy (GTK_WIDGET (dialog));
	g_error_free (err);
}

/*	display a popup for file errors		*/

void file_error_handling (GError *err)
{
	GtkWidget *dialog, *main;
	
	main = glade_xml_get_widget (xml, "Main");
	dialog = gtk_message_dialog_new (GTK_WINDOW (main), 
					 GTK_DIALOG_DESTROY_WITH_PARENT,
                                  	 GTK_MESSAGE_ERROR, 
                                  	 GTK_BUTTONS_CLOSE,
                                  	 "File-Error:\n\n%s", err->message);
 	gtk_dialog_run (GTK_DIALOG (dialog));
 	gtk_widget_destroy (GTK_WIDGET (dialog));
}

/*	X error handler		*/

int X_error (Display *display, XErrorEvent *event)
{
    	gchar text[60];
    	XGetErrorText (display, event->error_code, text, 60);
    	
    	g_warning ("\nXlib said: %s\nerror code %d, request code %d\n", 
    							text,
    							event->error_code,
    							event->request_code);	
	return 0;
}

/* 	read our own config values 	*/

void own_config (void)
{
	GError *err = NULL;
	GConfValue *check = NULL;
	GtkWidget *widget;
	gboolean toolbar, version;
	gint preview, i;
	gchar *path[] = {"/apps/gset-compiz/toolbar", 
			 "/apps/gset-compiz/preview",
			 "/apps/gset-compiz/version"};
	
	for (i=0; i<3; i++) {
		check = gconf_client_get (client, path[i], &err);
	
		if (check == NULL) {
			gconf_client_set_bool (client, path[0], TRUE, &err);
			gconf_client_set_int (client, path[1], 0, &err);
			gconf_client_set_bool (client, path[2], TRUE, &err);
		}
	}
	
	gconf_value_free (check);
		
	toolbar = gconf_client_get_bool (client, path[0], &err);	
	widget = glade_xml_get_widget (xml, "show_toolbar");
	gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (widget), toolbar);
	
	preview = gconf_client_get_int (client, path[1], &err);	
	widget = glade_xml_get_widget (xml, "slide_preview");
	gtk_combo_box_set_active (GTK_COMBO_BOX (widget), preview);
	
	version = gconf_client_get_bool (client, path[2], &err);	
	widget = glade_xml_get_widget (xml, "menu_version");
	gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (widget), version);
}

void change_version (gboolean show)
{
	GtkWidget *widget;	
	GtkTreeViewColumn *c;
	guint i;
	
	const gchar *widget_list[] = {	
		/* additional plugins */
		"miniwin", "miniwin_shorts", "dock", "dock_shorts", 
		"trailfocus", "bs", "bs_shorts", "state",		 
		"place_shorts", "resize",
		/* cube */		 
		"image_position", "Cube_additional",
		/* decoration */
		"Deco_additional",
		/* fade */
		"Fade_urgent_frame",
		/* minimize */
		"Mini_additional",
		/* rotate */
		"Rot_additional",
		/* scale */
		"Scale_additional", "Scale_darkenfactor", "Scale_short_addit",
		"Scale_short_prev",
		/* switcher */
		"Swi_additional", "Swi_desktops",
		/* wobbly */
		"Wobbly_additional", "Wobbly_add2", 
		/* zoom */
		"Zoom_additional"};
		
	widget = glade_xml_get_widget (xml, "Scale_corners");
	c = gtk_tree_view_get_column (GTK_TREE_VIEW (widget), 2);
	gtk_tree_view_column_set_visible (c, show);
	c = gtk_tree_view_get_column (GTK_TREE_VIEW (widget), 3);
	gtk_tree_view_column_set_visible (c, show);
	
	if (show) {
		for (i=0; i<25; i++) {
			widget = glade_xml_get_widget (xml, widget_list[i]);
			gtk_widget_show (widget);
		}	
		
		widget = glade_xml_get_widget (xml, "Wobbly_vanilla");
		gtk_widget_hide (widget);
		widget = glade_xml_get_widget (xml, "Cube_scale");
		gtk_widget_hide (widget);
	}
	
	if (!show) {
		for (i=0; i<25; i++) {
			widget = glade_xml_get_widget (xml, widget_list[i]);
			gtk_widget_hide (widget);
		}
		
		widget = glade_xml_get_widget (xml, "Wobbly_vanilla");
		gtk_widget_show (widget);
		widget = glade_xml_get_widget (xml, "Cube_scale");
		gtk_widget_show (widget);
	}
}
